{{- if .Values.config.pgadmin.enabled }}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: pgadmin
  labels:
    app: pgadmin
    chart: {{ .Chart.Name }}-{{ .Chart.Version }}
    release: {{ .Release.Name }}
    heritage: {{ .Release.Service }}
spec:
  selector:
    matchLabels:
      app: pgadmin
      release: {{ .Release.Name }}
  strategy:
    type: {{ .Values.config.updateStrategy }}
  template:
    metadata:
      labels:
        app: pgadmin
        release: {{ .Release.Name }}
    spec:
      affinity:
        nodeAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - weight: 89
              preference:
                matchExpressions:
                  - key: application/state
                    operator: In
                    values:
                      - stateless
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - weight: 90
              podAffinityTerm:
                topologyKey: kubernetes.io/hostname
                labelSelector:
                  matchExpressions:
                    - key: app
                      operator: In
                      values:
                        - pgadmin
                    - key: release
                      operator: In
                      values:
                        - {{ .Release.Name }}
      containers:
        - name: pgadmin
          image: {{ .Values.images.pgadmin.repository }}:{{ .Values.images.pgadmin.tag }}
          imagePullPolicy: {{ .Values.config.imagePullPolicy }}
{{- if (and .Values.config.pgadmin.resources.enabled (not (eq .Values.config.pgadmin.resources.enabled "false"))) }}
          resources:
            requests:
{{ toYaml .Values.config.pgadmin.resources.requests | indent 14 }}
            limits:
{{ toYaml .Values.config.pgadmin.resources.limits | indent 14 }}
{{- end }}
          ports:
            - name: container
              containerPort: 80
          volumeMounts:
            - name: config
              mountPath: /config
          env:
            - name: PGADMIN_SERVER_JSON_FILE
              value: /config/servers.json
            - name: PGADMIN_DEFAULT_EMAIL
              value: {{ .Values.config.pgadmin.email | quote }}
            - name: PGADMIN_DEFAULT_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: pgadmin
                  key: password
          livenessProbe:
            httpGet:
              path: /
              port: container
{{ toYaml .Values.probes.liveness | indent 12 }}
          readinessProbe:
            httpGet:
              path: /
              port: container
{{ toYaml .Values.probes.readiness | indent 12 }}
      volumes:
        - name: config
          configMap:
            name: pgadmin
{{- end }}
